Attribute VB_Name = "Registry"
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

Public Type RegNFO
    Root As Long
    Key As String
End Type

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_READ = KEY_QUERY_VALUE Or _
                         KEY_ENUMERATE_SUB_KEYS _
                         Or KEY_NOTIFY
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or _
                               KEY_SET_VALUE Or _
                               KEY_CREATE_SUB_KEY Or _
                               KEY_ENUMERATE_SUB_KEYS Or _
                               KEY_NOTIFY Or _
                               KEY_CREATE_LINK
Private Const ERROR_SUCCESS = 0&

Private Const REG_NONE = 0
Private Const REG_SZ = 1
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_DWORD_LITTLE_ENDIAN = 4
Private Const REG_DWORD_BIG_ENDIAN = 5
Private Const REG_LINK = 6
Private Const REG_MULTI_SZ = 7

Private Const REG_OPTION_NON_VOLATILE = &H0

Public Reg As RegNFO
Public Regroot As Long
Public Function RegKeyExist(Root As Long, _
                            Key As String) As Boolean
    Dim Result As Long, hKey As Long
    
    RegKeyExist = False
    Result = RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey)
    
    If Result = ERROR_SUCCESS Then _
        Call RegCloseKey(hKey): _
        RegKeyExist = True

End Function
Public Function RegKeyCreate(Root As Long, _
                             Newkey As String) As Long
    Dim Result As Long, hKey As Long, Back As Long
  
    Result = RegCreateKeyEx(Root, Newkey, 0, vbNullString, _
                            REG_OPTION_NON_VOLATILE, _
                            KEY_ALL_ACCESS, 0&, hKey, Back)
    
    If Result = ERROR_SUCCESS Then
        Result = RegFlushKey(hKey)
        If Result = ERROR_SUCCESS Then Call RegCloseKey(hKey)
        RegKeyCreate = Back
    End If
    
End Function
Public Function RegKeyDelete(Root As Long, _
                             Key As String) As Long
    RegKeyDelete = RegDeleteKey(Root, Key)
End Function
Public Function RegFieldDelete(Root As Long, _
                               Key As String, _
                               Field As String) As Long
    Dim Result As Long, hKey As Long
    
    Result = RegOpenKeyEx(Root, Key, 0, _
                          KEY_ALL_ACCESS, hKey)
    
    If Result = ERROR_SUCCESS Then
        Result = RegDeleteValue(hKey, Field)
        Result = RegCloseKey(hKey)
    End If
    
    RegFieldDelete = Result

End Function
Public Function RegValueSet(Root As Long, _
                            Key As String, _
                            Field As String, _
                            Value As Variant) As Long
    Dim Result As Long, hKey As Long, l As Long
    Dim s$
  
    Result = RegOpenKeyEx(Root, Key, 0, _
                          KEY_ALL_ACCESS, hKey)
    
    If Result = ERROR_SUCCESS Then
        Select Case VarType(Value)
            Case vbInteger, vbLong
                l = CLng(Value)
                Result = RegSetValueEx(hKey, Field, 0, _
                                       REG_DWORD, l, 4)
            Case vbString, vbBoolean
                s = CStr(Value)
                Result = RegSetValueEx_Str(hKey, Field, 0, _
                                           REG_SZ, s, _
                                           Len(s) + 1)
        End Select
        Result = RegCloseKey(hKey)
    End If
    
    RegValueSet = Result
    
End Function
Public Function RegValueGet(Root As Long, _
                            Key As String, _
                            Field As String) As Variant
    Dim Result As Long, hKey As Long, dwType As Long
    Dim Lng As Long, l As Long
    Dim Buffer As String
  
    Result = RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey)
  
    If Result = ERROR_SUCCESS Then
        Result = RegQueryValueEx(hKey, Field, 0&, _
                                 dwType, ByVal 0&, l)
        If Result = ERROR_SUCCESS Then
            Select Case dwType
                Case REG_SZ
                    Buffer = Space$(l + 1)
                    Result = RegQueryValueEx(hKey, Field, _
                                             0&, dwType, _
                                             ByVal Buffer, l)
                    If Result = ERROR_SUCCESS Then _
                        RegValueGet = Left(Buffer, Len(Buffer) - 2)
                Case REG_DWORD
                    Result = RegQueryValueEx(hKey, Field, _
                                             0&, dwType, _
                                             Lng, l)
                    If Result = ERROR_SUCCESS Then _
                        RegValueGet = Lng
            End Select
        End If
    End If
    
    If Result = ERROR_SUCCESS Then _
        Result = RegCloseKey(hKey)
    
End Function
